image: golang:latest

variables:
  REPO_NAME: "gitlab.com/marcello.urbani/meetup-2020-cw17"


before_script:
    - mkdir -p $GOPATH/src/$(dirname $REPO_NAME)
    - ln -svf $CI_PROJECT_DIR $GOPATH/src/$REPO_NAME
    - cd $GOPATH/src/$REPO_NAME

stages:
    - test
    - build
    - deploy

format:
    stage: test
    script:
      - go fmt $(go list ./...|grep -v /vendor/)
      - go vet $(go list ./...|grep -v /vendor/)
      - go test -race $(go list ./...|grep -v /vendor/)

compile:
    stage: build
    script:
      - go build -race -ldflags "-extldflags '-static'" -o $CI_PROJECT_DIR/tanuki
    artifacts:
      paths:
        - tanuki
